/**	@file
  *	@brief  .   
  *
  *	
  */

#ifndef mil1553UdREGS_H
#define mil1553UdREGS_H

/// \remark    BAR0

#define DMA_DATA_BASE           0x1000  // RW
#define DMA_INDEX_CH1           0x1040  // RW
#define DMA_INDEX_CH2           0x1044  // RW
#define DMA_INDEX_CH3           0x1048  // RW
#define DMA_INDEX_CH4           0x104C  // RW

/// \remark 
#define INTERRUPT               0x100C  // R
#define INTERRUPT_MASK          0x1010  // RW

/// \remark   FLASH
#define BUF_FLASH_PROG          0x0     // RW
#define BUF_FLASH_PROG_SIZE     0xFC    //     (256)
#define PROG_CONTROL_STATUS     0x1014  // RW
#define PROG_ADDRESS            0x1018  // RW
#define HI_ADDR_SELECT_REG      0x101C  // W
#define RESERV_ADDR_WR_PROT_REG 0x1020  // W
#define FPGA_BOOT               0x1024  // W
#define FPGA_BOOT_STATUS        0x1034  // R

/// \remark  1
#define CTRL_REG_PCI_CH1        0x2000  // W
#define RTBM_CONF_REG_PCI_CH1   0x2004  // W
#define BC_CONF_REG_PCI_CH1     0x2008  // W
#define TIME_UTIL_REG_PCI_CH1   0x200C  // RW
#define TIME_MATCH_REG_PCI_CH1  0x2010  // RW
#define VECW_REG_CH1            0x2014  // W
#define BITW_REG_CH1            0x2018  // W
#define STHW_REG_CH1            0x201C  // W
#define OSTHW_REG_CH1           0x2020  // W
#define MODER_REG_CH1           0x2024  // RW
#define MODET_REG_CH1           0x2028  // RW
#define RT_INT_REG_CH1          0x2034  // RW
#define FREE_TIMER_CH1          0x2038  // RW
#define EPROM_CONFIG_CH1        0x207C  // RW
#define HW_STAT_REG1_CH1        0x2080  // R
#define HW_STAT_REG2_CH1        0x2084  // R
#define MIL_STA_REG_CH1         0x2088  // RW
#define GPF_BC_COND_CODE_CH1    0x2090  // RW
#define START_ADR_INSTR_PTR_CH1 0x2094  // RW
#define BC_FRAME_TIME_REM_CH1   0x2098  // R
#define BC_TIME_TAG_COUNTER_CH1 0x209C  // R
#define OP_DATA_RAM_PTR_CH1     0x20A0  // R
#define RT_RCV_REG_CH1          0x2100  // RW
#define RT_TR_REG_CH1           0x2180  // RW
#define DIS_RCV_REG_CH1         0x2200  // W
#define DIS_TR_REG_CH1          0x2280  // W
#define RT_DATA_BUF0_CH1        0x2800  // W
#define RT_DATA_BUF1_CH1        0x3000  // W
#define BC_DATA_RAM_CH1         0x10000 // RW
#define BC_INSTR_RAM_CH1        0x18000 // RW
#define BC_OPERATION_RAM_CH1    0x1C000 // RW
#define TESTER_ERROR_CONF_REG_CH1   0x202C  // RW
#define TESTER_WRD_NUM_REG_CH1      0x2030  // RW
#define CTR_TIMEOUT_ABSOLUTR_CH1    0x1050  // RW
#define CTR_TIMEOUT_INTERVAL_CH1    0x1060  // RW
#define CTR_DATA_COUNTER_CH1        0x1070  // RW

/// \remark  2
#define CTRL_REG_PCI_CH2        0x4000  // W
#define RTBM_CONF_REG_PCI_CH2   0x4004  // W
#define BC_CONF_REG_PCI_CH2     0x4008  // W
#define TIME_UTIL_REG_PCI_CH2   0x400C  // RW
#define TIME_MATCH_REG_PCI_CH2  0x4010  // RW
#define VECW_REG_CH2            0x4014  // W
#define BITW_REG_CH2            0x4018  // W
#define STHW_REG_CH2            0x401C  // W
#define OSTHW_REG_CH2           0x4020  // W
#define MODER_REG_CH2           0x4024  // RW
#define MODET_REG_CH2           0x4028  // RW
#define RT_INT_REG_CH2          0x4034  // RW
#define FREE_TIMER_CH2          0x4038  // RW
#define EPROM_CONFIG_CH2        0x407C  // RW
#define HW_STAT_REG1_CH2        0x4080  // R
#define HW_STAT_REG2_CH2        0x4084  // R
#define MIL_STA_REG_CH2         0x4088  // RW
#define GPF_BC_COND_CODE_CH2    0x4090  // RW
#define START_ADR_INSTR_PTR_CH2 0x4094  // RW
#define BC_FRAME_TIME_REM_CH2   0x4098  // R
#define BC_TIME_TAG_COUNTER_CH2 0x409C  // R
#define OP_DATA_RAM_PTR_CH2     0x40A0  // R
#define RT_RCV_REG_CH2          0x4100  // RW
#define RT_TR_REG_CH2           0x4180  // RW
#define DIS_RCV_REG_CH2         0x4200  // W
#define DIS_TR_REG_CH2          0x4280  // W
#define RT_DATA_BUF0_CH2        0x4800  // W
#define RT_DATA_BUF1_CH2        0x5000  // W
#define BC_DATA_RAM_CH2         0x20000 // RW
#define BC_INSTR_RAM_CH2        0x28000 // RW
#define BC_OPERATION_RAM_CH2    0x2C000 // RW
#define TESTER_ERROR_CONF_REG_CH2   0x402C  // RW
#define TESTER_WRD_NUM_REG_CH2      0x4030  // RW
#define CTR_TIMEOUT_ABSOLUTR_CH2    0x1054  // RW
#define CTR_TIMEOUT_INTERVAL_CH2    0x1064  // RW
#define CTR_DATA_COUNTER_CH2        0x1074  // RW

/// \remark  3
#define CTRL_REG_PCI_CH3        0x6000  // W
#define RTBM_CONF_REG_PCI_CH3   0x6004  // W
#define BC_CONF_REG_PCI_CH3     0x6008  // W
#define TIME_UTIL_REG_PCI_CH3   0x600C  // RW
#define TIME_MATCH_REG_PCI_CH3  0x6010  // RW
#define VECW_REG_CH3            0x6014  // W
#define BITW_REG_CH3            0x6018  // W
#define STHW_REG_CH3            0x601C  // W
#define OSTHW_REG_CH3           0x6020  // W
#define MODER_REG_CH3           0x6024  // RW
#define MODET_REG_CH3           0x6028  // RW
#define RT_INT_REG_CH3          0x6034  // RW
#define FREE_TIMER_CH3          0x6038  // RW
#define EPROM_CONFIG_CH3        0x607C  // RW
#define HW_STAT_REG1_CH3        0x6080  // R
#define HW_STAT_REG2_CH3        0x6084  // R
#define MIL_STA_REG_CH3         0x6088  // RW
#define GPF_BC_COND_CODE_CH3    0x6090  // RW
#define START_ADR_INSTR_PTR_CH3 0x6094  // RW
#define BC_FRAME_TIME_REM_CH3   0x6098  // R
#define BC_TIME_TAG_COUNTER_CH3 0x609C  // R
#define OP_DATA_RAM_PTR_CH3     0x60A0  // R
#define RT_RCV_REG_CH3          0x6100  // RW
#define RT_TR_REG_CH3           0x6180  // RW
#define DIS_RCV_REG_CH3         0x6200  // W
#define DIS_TR_REG_CH3          0x6280  // W
#define RT_DATA_BUF0_CH3        0x6800  // W
#define RT_DATA_BUF1_CH3        0x7000  // W
#define BC_DATA_RAM_CH3         0x30000 // RW
#define BC_INSTR_RAM_CH3        0x38000 // RW
#define BC_OPERATION_RAM_CH3    0x3C000 // RW
#define TESTER_ERROR_CONF_REG_CH3   0x602C  // RW
#define TESTER_WRD_NUM_REG_CH3      0x6030  // RW
#define CTR_TIMEOUT_ABSOLUTR_CH3    0x1058  // RW
#define CTR_TIMEOUT_INTERVAL_CH3    0x1068  // RW
#define CTR_DATA_COUNTER_CH3        0x1078  // RW

/// \remark  4
#define CTRL_REG_PCI_CH4        0x8000  // W
#define RTBM_CONF_REG_PCI_CH4   0x8004  // W
#define BC_CONF_REG_PCI_CH4     0x8008  // W
#define TIME_UTIL_REG_PCI_CH4   0x800C  // RW
#define TIME_MATCH_REG_PCI_CH4  0x8010  // RW
#define VECW_REG_CH4            0x8014  // W
#define BITW_REG_CH4            0x8018  // W
#define STHW_REG_CH4            0x801C  // W
#define OSTHW_REG_CH4           0x8020  // W
#define MODER_REG_CH4           0x8024  // RW
#define MODET_REG_CH4           0x8028  // RW
#define RT_INT_REG_CH4          0x8034  // RW
#define FREE_TIMER_CH4          0x8038  // RW
#define EPROM_CONFIG_CH4        0x807C  // RW
#define HW_STAT_REG1_CH4        0x8080  // R
#define HW_STAT_REG2_CH4        0x8084  // R
#define MIL_STA_REG_CH4         0x8088  // RW
#define GPF_BC_COND_CODE_CH4    0x8090  // RW
#define START_ADR_INSTR_PTR_CH4 0x8094  // RW
#define BC_FRAME_TIME_REM_CH4   0x8098  // R
#define BC_TIME_TAG_COUNTER_CH4 0x809C  // R
#define OP_DATA_RAM_PTR_CH4     0x80A0  // R
#define RT_RCV_REG_CH4          0x8100  // RW
#define RT_TR_REG_CH4           0x8180  // RW
#define DIS_RCV_REG_CH4         0x8200  // W
#define DIS_TR_REG_CH4          0x8280  // W
#define RT_DATA_BUF0_CH4        0x8800  // W
#define RT_DATA_BUF1_CH4        0x9000  // W
#define BC_DATA_RAM_CH4         0x40000 // RW
#define BC_INSTR_RAM_CH4        0x48000 // RW
#define BC_OPERATION_RAM_CH4    0x4C000 // RW
#define TESTER_ERROR_CONF_REG_CH4   0x802C  // RW
#define TESTER_WRD_NUM_REG_CH4      0x8030  // RW
#define CTR_TIMEOUT_ABSOLUTR_CH4    0x105C  // RW
#define CTR_TIMEOUT_INTERVAL_CH4    0x106C  // RW
#define CTR_DATA_COUNTER_CH4        0x107C  // RW

#endif