/**	@file
  *	@brief  .  IOCTL   
  *
  *	
  */

#include "mil1553regs.h"

#ifndef MAXIMUM_FILENAME_LENGTH
#define MAXIMUM_FILENAME_LENGTH 256
#endif

#ifndef __mil1553UdH__
#define __mil1553UdH__

#include <winioctl.h>
#include <initguid.h>

DEFINE_GUID(GUID_DEVINTERFACE_MIL1553, 0x3BD2B180, 0xD211, 0x4D88, 0x8F, 0x46, 0xB7, 0x38, 0x45, 0xCF, 0x38, 0xFB);

//
//	IN SADDR_DATA
//	OUT NULL
#define IOCTL_WRITE_REG						CTL_CODE(FILE_DEVICE_CONTROLLER, 0, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 
//	IN SADDR_DATA_BIT_MASK
//	OUT NULL
#define IOCTL_WRITE_REG_BIT_MASK			CTL_CODE(FILE_DEVICE_CONTROLLER, 1, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN SADDR_DATA
//	OUT SADDR_DATA
#define IOCTL_READ_REG						CTL_CODE(FILE_DEVICE_CONTROLLER, 2, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 


//
//	OUT VERSION
#define IOCTL_VERSION						CTL_CODE(FILE_DEVICE_CONTROLLER, 31, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 
//	OUT UINT32
#define IOCTL_VERSION_DRIVER				CTL_CODE(FILE_DEVICE_CONTROLLER, 40, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 
//	NOT IMPLEMENTED YET
#define IOCTL_PCI_LOCATION					CTL_CODE(FILE_DEVICE_CONTROLLER, 41, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  


//DMA
//	IN MODE_DATA
#define IOCTL_CLEAR_DMA						CTL_CODE(FILE_DEVICE_CONTROLLER, 5, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 
//	IN MODE_DATA
#define IOCTL_ENABLE_DMA					CTL_CODE(FILE_DEVICE_CONTROLLER, 8, METHOD_BUFFERED, FILE_ANY_ACCESS)	// DMA
//	IN MODE_DATA
#define IOCTL_DISABLE_DMA					CTL_CODE(FILE_DEVICE_CONTROLLER, 9, METHOD_BUFFERED, FILE_ANY_ACCESS)	// DMA
//	IN DMA_COUNT_REQUEST
//	OUT DMA_COUNT_REQUEST
#define IOCTL_GET_NBLOCKS_RAW_DMA			CTL_CODE(FILE_DEVICE_CONTROLLER, 7, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  
//	IN DMA_READ_BLOCK
//	OUT DMA_READ_BLOCK
#define IOCTL_READ_BLOCKS_RAW_DMA			CTL_CODE(FILE_DEVICE_CONTROLLER, 6, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 


//
//	IN INTERRUPT_MAN
#define IOCTL_MANAGE_INTERRUPT				CTL_CODE(FILE_DEVICE_CONTROLLER, 16, METHOD_BUFFERED, FILE_ANY_ACCESS)	// 
//	IN INTERRUPT_SUBADDRESS
#define IOCTL_MAN_IRQ_SUBADDRESS_TR			CTL_CODE(FILE_DEVICE_CONTROLLER, 38, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN INTERRUPT_SUBADDRESS
#define IOCTL_MAN_IRQ_SUBADDRESS_RCV		CTL_CODE(FILE_DEVICE_CONTROLLER, 39, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   


// 
//	IN MODE_DATA
#define IOCTL_SWITCH_MODE					CTL_CODE(FILE_DEVICE_CONTROLLER, 4, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN MODE_DATA
#define IOCTL_SWITCH_BUS					CTL_CODE(FILE_DEVICE_CONTROLLER, 33, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  
//	IN MODE_DATA
#define IOCTL_DEV_CHANNEL_WORK				CTL_CODE(FILE_DEVICE_CONTROLLER, 34, METHOD_BUFFERED, FILE_ANY_ACCESS)	/// 


//
//	IN RT_TR_MODE
#define IOCTL_SET_RT_TR_MODE				CTL_CODE(FILE_DEVICE_CONTROLLER, 35, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  
//	IN RT_TR_MODE_BUF
#define IOCTL_SET_RT_TR_BUF_READY			CTL_CODE(FILE_DEVICE_CONTROLLER, 37, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN RT_BUF_MAN_EN
#define IOCTL_RT_BUF_MAN_EN					CTL_CODE(FILE_DEVICE_CONTROLLER, 36, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN ADDRESS_REQ
#define IOCTL_SET_ADDRESS					CTL_CODE(FILE_DEVICE_CONTROLLER, 19, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  

//
//	IN TIMER_TIMEOUT
#define IOCTL_SET_TIMER_RTBM_CONF_REG_PCI	CTL_CODE(FILE_DEVICE_CONTROLLER, 20, METHOD_BUFFERED, FILE_ANY_ACCESS)	//    /
//	IN TIMER_TIMEOUT
#define IOCTL_SET_TIMER_BC_CONF_REG_PCI		CTL_CODE(FILE_DEVICE_CONTROLLER, 32, METHOD_BUFFERED, FILE_ANY_ACCESS)	//    

//- 
//	IN
#define IOCTL_WR_BLOCK_BUF_SUBADDR			CTL_CODE(FILE_DEVICE_CONTROLLER, 27, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  
//	IN
//	OUT
#define IOCTL_RD_BLOCK_BUF_SUBADDR			CTL_CODE(FILE_DEVICE_CONTROLLER, 28, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  

//
//	IN BC_RAM_BLOCK
#define IOCTL_WRITE_BC_RAM					CTL_CODE(FILE_DEVICE_CONTROLLER, 29, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   
//	IN BC_RAM_BLOCK
//	OUT BC_RAM_BLOCK
#define IOCTL_READ_BC_RAM					CTL_CODE(FILE_DEVICE_CONTROLLER, 30, METHOD_BUFFERED, FILE_ANY_ACCESS)	//   

//   
//	IN UINT8
//	OUT UINT32
#define IOCTL_GET_COUNT_INTERRUPT_BLOCKS	CTL_CODE(FILE_DEVICE_CONTROLLER, 50, METHOD_BUFFERED, FILE_ANY_ACCESS)	//    
//	IN BLOCK_INFO
//	OUT BLOCK_INFO
#define IOCTL_READ_INTERRUPT_BLOCKS			CTL_CODE(FILE_DEVICE_CONTROLLER, 51, METHOD_BUFFERED, FILE_ANY_ACCESS)	//     
//	IN SADDR_INFO
//	OUT SADDR_INFO
#define IOCTL_GET_RCV_SUBADDR_DATA			CTL_CODE(FILE_DEVICE_CONTROLLER, 52, METHOD_BUFFERED, FILE_ANY_ACCESS)	//  

///
/// \remark   IOCTL-
///

/// \remark    
/// 0 -   , 1 -  , 2 -  
/// \brief    
#define INTERRUPT_MAN_NO_CHANGE         0
/// \brief   
#define INTERRUPT_MAN_ON                1
/// \brief   
#define INTERRUPT_MAN_OFF               2

/// \remark    
/// \brief   
#define MIL_MODE_MONITOR_ADRR           0x0
/// \brief  
#define MIL_MODE_BUS_CONTR              0x1
/// \brief  
#define MIL_MODE_TERMINAL_DEV           0x2
/// \brief   
#define MIL_MODE_MONITOR                0x3

/// \remark    
/// \brief   
#define MIL_BUS_A_EN                    0x1
/// \brief   
#define MIL_BUS_B_EN                    0x2

/// \remark  / 
/// \brief    
#define MIL_DEV_CHANNEL_ON              0x1
/// \brief  
#define MIL_DEV_CHANNEL_OFF             0x0

/// \remark    
/// \brief  - 
#define MIL_RT_MODE_PROG                0x0
/// \brief  - 
#define MIL_RT_MODE_HRDW                0x1

/// \remark    cmd_buf
/// \brief   RTF_BUF0  RTF_BUF1 - 
#define MIL_RT_BUF_0_OFF_1_OFF          0x0
/// \brief   RTF_BUF0 -   RTF_BUF1 - 
#define MIL_RT_BUF_0_OFF_1_ON           0x1
/// \brief   RTF_BUF0 -   RTF_BUF1 - 
#define MIL_RT_BUF_0_ON_1_OFF           0x2
/// \brief   RTF_BUF0 -   RTF_BUF1 - 
#define MIL_RT_BUF_0_ON_1_ON            0x3

/// \remark   direction
/// \brief  - 
#define MIL_RT_BUF_TRANSMIT             0x0
/// \brief  - 
#define MIL_RT_BUF_RECEIVE              0x1

/// \remark   num_buf
/// \brief    RTF_BUF0
#define MIL_RT_BUF0                     0
/// \brief    RTF_BUF1
#define MIL_RT_BUF1                     1

/// \remark   timer timeout RCVCK
#define MIL_T_RCVCK_17MKS               0x0
#define MIL_T_RCVCK_60MKS               0x1
#define MIL_T_RCVCK_85MKS               0x2
#define MIL_T_RCVCK_110MKS              0x3

/// \remark   timer timeout TRCK
#define MIL_T_TRCK_6MKS                 0x0
#define MIL_T_TRCK_8MKS                 0x1
#define MIL_T_TRCK_11MKS                0x2
#define MIL_T_TRCK_13MKS                0x3
#define MIL_T_TRCK_18MKS                0x4
#define MIL_T_TRCK_61MKS                0x5
#define MIL_T_TRCK_86MKS                0x6
#define MIL_T_TRCK_111MKS               0x7

/// \remark   timer timeout TCK
#define MIL_T_TCK_OFF                   0x0
#define MIL_T_TCK_1MKS                  0x1
#define MIL_T_TCK_2MKS                  0x2
#define MIL_T_TCK_4MKS                  0x3
#define MIL_T_TCK_8MKS                  0x4
#define MIL_T_TCK_16MKS                 0x5
#define MIL_T_TCK_32MKS                 0x6
#define MIL_T_TCK_64MKS                 0x7

/// \remark    / BC RAM
#define MIL_BC_RAM_TYPE_INSTRUCTION     0x0
#define MIL_BC_RAM_TYPE_OPERATION       0x1
#define MIL_BC_RAM_TYPE_DATA            0x2

/// \remark  
/// \brief  1
#define CH_NUM_1            0
/// \brief  2
#define CH_NUM_2            1
/// \brief  3
#define CH_NUM_3            2
/// \brief  4
#define CH_NUM_4            3

/// \brief    
struct BlockInfo {
    /// \brief     
    UINT32    free_timer_value;
    /// \brief   (          )
    /// 0 - INT_HDAT, 1 - INT_QDAT, 2 - RT_INT_SADDR, 3 - RT_INT_MC_ERR,
    /// 4 - INT_BC, 5 - INT_FLASH, 6 - INT_DATA_CNT_EN,
    /// 7 - INT_TIMEOUT_ITVEN, 8 - INT_TIMEOUT_ABSEN
    UINT32    interrupt_ch;
    /// \brief  HW_STAT_REG1
    UINT32    hw_stat_reg1;
    /// \brief  HW_STAT_REG2
    UINT32    hw_stat_reg2;
};

#define BLINF_INT_HDAT          0
#define BLINF_INT_QDAT          1
#define BLINF_RT_INT_SADDR      2
#define BLINF_RT_INT_MC_ERR     3
#define BLINF_INT_BC            4
#define BLINF_INT_FLASH         5
#define BLINT_INT_DATA_CNT_EN   6
#define BLINT_TIMEOUT_ITVEN     7
#define BLINT_TIMEOUT_ABSEN     8

#define SIZE_OF_PCI_LOC         13



typedef struct _MODE_DATA{
	UINT8 channel;	//
	UINT8 mode;		//   ( )
} MODE_DATA, *PMODE_DATA;


// 
// 

typedef struct _DMA_COUNT_REQUEST{
	UINT8 channel;	//
	UINT32 count;	// 
} DMA_COUNT_REQUEST, *PDMA_COUNT_REQUEST;

typedef struct _ADDRESS_REQ{
	UINT8 channel;
	UINT8 address;
} ADDRESS_REQ, *PADDRESS_REQ;

///
/// \remark    IOCTL-
///

/// \brief      pci
typedef struct {
    ///
    /// \brief name   
    /// , 0000:00:02.0 -
    ///   (16 ),  (8 ),  (5 )   (3 )
    ///
    char name[SIZE_OF_PCI_LOC];
} PCI_LOCATION;

/// \brief     
typedef struct {
    /// \brief  
    UINT32 device_id;
    /// \brief  
    UINT32 vendor_id;
    /// \brief   (- )
    UINT32 type;
    /// \brief  
    char revision;
    /// \brief   
    char dev_name[MAXIMUM_FILENAME_LENGTH];
    /// \brief  
    int minor;
    /// \brief  
    int irq;
    /// \brief   
    UINT32 size_dma;
    /// \brief    
    //void* addr_dma_virt;
    /// \brief  bar-
    UINT32 pci_bars;
    /// \brief   bar-
    //void* addr_bar_virt;
} VERSION;

// / 
typedef struct {
    //   (  .  )
    UINT32 daddr;
    //  
    UINT32 data;
	//  
	UINT8 channel;
} SADDR_DATA;

/// \brief     
typedef struct {
    /// \brief   (  .  )
    UINT32 daddr;
    /// \brief  
    UINT32 data;
    /// \brief  
    /// 1 -    data, 0 -   
    UINT32 mask;

	UINT8 channel;
} SADDR_DATA_BIT_MASK;

#define DMA_RAW_BLOCK_SIZE		128
#define DMA_SUPERBLOCK_SIZE		8192 * DMA_RAW_BLOCK_SIZE

/// \brief   ,  128 
typedef struct {
    //  128  
    UINT32 countBlocks;
    //     
    UINT8 data[DMA_SUPERBLOCK_SIZE];
	//
	UINT8 channel;
} DMA_READ_BLOCK;

/// \remark      

/// \brief    
typedef struct {
    /// \brief     flash
    UINT8 int_flash;
    /// \brief    
    UINT8 int_bc;
    /// \brief       
    UINT8 int_rt_ren;
    /// \brief       
    UINT8 int_rt_ten;
    /// \brief     1/18
    UINT8 int_qdat;
    /// \brief     1/2
    UINT8 int_hdat;
    /// \brief      MIL
    UINT8 int_data_cnt_en;
    /// \brief     MIL
    UINT8 int_timeout_itven;
    /// \brief     MIL
    UINT8 int_timeout_absen;
	//
	UINT8 channel;
} INTERRUPT_MAN;

/// \brief     /   
typedef struct {
    /// \brief   ( - 1 /  - 2)
    UINT8 rt_int;
    /// \brief     1  - 1   ..
    UINT32 subaddress_mask;
	//
	UINT8 channel;
} INTERRUPT_SUBADDRESS;

/// \remark      

/// \brief      
typedef struct {
    // 
    UINT8 subaddress;
    // 
    UINT32 mode;
	//
	UINT8 channel;
} RT_TR_MODE;

/// \brief   1  2
typedef struct {
    //  1 - 30
    UINT8 subaddress;
    //  . 
    UINT32 cmd_buf;
	//
	UINT8 channel;
} RT_TR_MODE_BUF;

/// \brief     
typedef struct {
    //  (/)
    UINT32 direction;
    //  ()   1  - 1   ..
    /// 1 -  , 0 -   
    UINT32 subaddress_mask;
    //  ()    1  - 1   ..
    // 1 - , 0 - 
    UINT32 action_mask;
	//
	UINT8 channel;
} RT_BUF_MAN_EN;

/// \brief     
typedef struct {
    UINT8 num_buf;			//  
    UINT8 subaddress;		//  (1-30)
    UINT16 data_words[32];	//  (32  )
	UINT8 channel;			// 
} RT_TR_BUF_SUBADDR;

/// \brief   
typedef struct {
    //  RT_TCK
    UINT32 tck;
    //  RT_TRCK
    UINT32 trck;
    //   RT_RCVCK
    UINT32 rcvck;
	// 
	UINT8 channel;
} TIMER_TIMEOUT;

#define BC_RAM_MAX 8192

/// \brief      BC_RAM (   )
typedef struct {
    /// \brief  
    /// INSTR, OPERATION, DATA
    UINT32 type;
    /// \brief      32-  
    /// INSTR - max 4095, OPERATION - max 4095, DATA - max 8191
    UINT32 shift;
    //   dwords
    UINT32 length;
    // 
    UINT32 dwords[BC_RAM_MAX];
	// 
	UINT8 channel;
} BC_RAM_BLOCK;

#define INTERRUPT_BLOCKS_MAX 2048

/// \brief      
typedef struct {
	UINT8 channel;
    /// \brief -  
    UINT32        count_blocks;
    /// \brief     
    struct BlockInfo  blocks[INTERRUPT_BLOCKS_MAX];
} INTERRUPT_BLOCK_BUFFER;

/// \brief   
typedef struct {
    /// \brief  (1-30)
    UINT8 sa;
    /// \brief  
    UINT16 words[32];
	UINT8 channel;
} SUBA_DATA_BLOCK;

/// \brief    
typedef struct {
    /// \brief pid  
    ///  
    int target_pid;
    /// \brief  
    int sig_number;
}
SIGNAL_INFO;

#endif //__mil1553UdH__